--------------------------------------------------------------------------------
-- Weapon Turn Extender - Use Two Weapons per turn
-- Original Carnage Contest Weapon
-- Script by Coolo, Mai 2011, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
if cc.turnextender ~= nil then
	useweapon = cc.turnextender.save_useweapon
	endturn = cc.turnextender.save_newturn
end
cc.turnextender={}


--------------------------------------------------------------------------------
-- Weapon: turnextender
--------------------------------------------------------------------------------
cc.turnextender.sfx_turn=loadsfx("timebonus.ogg")
cc.turnextender.gfx_icon = loadgfx("cooloweapon/turnextender.png")
setmidhandle(cc.turnextender.gfx_icon)
cc.turnextender.id=addweapon("cc.turnextender","Turn Extender",cc.turnextender.gfx_icon,0,2)	-- Add Weapon
cc.turnextender.used = false
cc.turnextender.save_useweapon = useweapon
cc.turnextender.save_endturn = endturn
cc.turnextender.use_turn = -2
cc.turnextender.new_useweapon = function(param)
	if cc.turnextender.use_turn ~= getturn() then
		cc.turnextender.save_useweapon(param)
	else
		cc.turnextender.save_useweapon(1)
	end
end
cc.turnextender.new_endturn = function()
	endturn = cc.turnextender.save_endturn
	useweapon = cc.turnextender.save_useweapon
	
	cc.turnextender.used = false
	
	if cc.turnextender.use_turn ~= getturn() then
		endturn()
	end
end 

function cc.turnextender.draw()										-- Draw
	if not cc.turnextender.used then
		hudinfo("Use two weapons.")
	end
end

function cc.turnextender.attack(attack)								-- Attack
	if attack == 1 and not cc.turnextender.used then
		useweapon(1)
		useweapon = cc.turnextender.new_useweapon
		endturn = cc.turnextender.new_endturn
		cc.turnextender.used = true
		cc.turnextender.use_turn = getturn()
		
		playsound(cc.turnextender.sfx_turn)
		x=getplayerx(0)
		y=getplayery(0)+3
		particle(p_muzzle,x,y)
		particlesize(1,1)
		particlecolor(0,0,255)
		particlealpha(1.0)
		particlefadealpha(0.01)
		particle(p_muzzle,x,y)
		particlesize(1,2)
		particlecolor(255,255,0)
		particlealpha(1.0)
		particlefadealpha(0.02)
		particlerotation(0)
		for j=1,15,1 do
			particle(p_flare,x-10.0+math.random()*20.0,y+math.random()*10.0)
			particlesize(3.0,3.0)
			particlecolor(0,0,255)
			particlespeed(0,math.random(2,15)*-0.1)
			particlefadealpha(0.01)
		end
	end
end
